/*

--------
|SKRUZD|
--------

The MIT License

Copyright (c) 2006 Inko Illarramendi

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/


#include <physicallayer/pl.h>
#include <behaviourlayer/bl.h>
#include <behaviourlayer/behave.h>
#include <propclass/actormove.h>
#include <propclass/meshsel.h>
#include <propclass/mesh.h>
#include <propclass/camera.h>
#include <propclass/inv.h>

#include <propclass/mover.h>

class BehaviourPlayer : public BehaviourCommon
{
private:
    csStringID id_pccommandinput_forward1;
    csStringID id_pccommandinput_forward0;
    csStringID id_pccommandinput_backward1;
    csStringID id_pccommandinput_backward0;
    csStringID id_pccommandinput_rotateleft1;
    csStringID id_pccommandinput_rotateleft0;
    csStringID id_pccommandinput_rotateright1;
    csStringID id_pccommandinput_rotateright0;
    csStringID id_pccommandinput_cammode1;
    csStringID id_pccommandinput_shot0;
    csStringID id_pccommandinput_shot1;
    csStringID id_pccommandinput_jump0;
    csStringID id_pccommandinput_jump1;

    csStringID id_pctimer_wakeupframe;
    csStringID id_pctimer_wakeup;

    csStringID id_pclinearmovement_collision;

/// Get the iPcActorMove property class of the player entity
    void GetActorMove ();
    csWeakRef<iPcActorMove> pcactormove;

/// Get the iPcMesh property class of the player entity
    void GetMesh ();
    csWeakRef<iPcMesh> pcmesh;

/// Activate the weapon which later will be checked in its own behaviour
    void Weapon();

public:

    BehaviourPlayer (iCelEntity* entity, BehaviourLayer* bl, iCelPlLayer* pl);
    virtual ~BehaviourPlayer ()
    { }

    virtual const char* GetName () const
    {
        return "player_behave";
    }
    virtual bool SendMessage (csStringID msg_id,
                              iCelPropertyClass* pc,
                              celData& ret, iCelParameterBlock* params, va_list arg);
};
